am, rebase: teach quiet option
[git/git.git] / git-rebase.sh
CommitLineData
59e6b23a
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano.
4#
5
0e987a12 6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
031321c6
SE
7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8same name. When the --onto option is provided the new branch starts
9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10It then attempts to create a new commit for each commit from the original
11<branch> that does not exist in the <upstream> branch.
69a60af5 12
031321c6
SE
13It is possible that a merge failure will prevent this process from being
14completely automatic. You will have to resolve any such merge failure
cc120056
SE
15and run git rebase --continue. Another option is to bypass the commit
16that caused the merge failure with git rebase --skip. To restore the
51ef1daa
JS
17original <branch> and remove the .git/rebase-apply working files, use the
18command git rebase --abort instead.
69a60af5 19
031321c6 20Note that if <branch> is not specified on the command line, the
702088af 21currently checked out branch is used.
e646c9c8 22
031321c6 23Example: git-rebase master~1 topic
e646c9c8 24
031321c6
SE
25 A---B---C topic A'\''--B'\''--C'\'' topic
26 / --> /
27 D---E---F---G master D---E---F---G master
e646c9c8 28'
533b7039
JH
29
30SUBDIRECTORY_OK=Yes
8f321a39 31OPTIONS_SPEC=
ae2b0f15 32. git-sh-setup
f9474132 33set_reflog_action rebase
7eff28a9 34require_work_tree
533b7039 35cd_to_toplevel
4282c4fb 36
c4427656 37OK_TO_SKIP_PRE_REBASE=
cc120056
SE
38RESOLVEMSG="
39When you have resolved this problem run \"git rebase --continue\".
40If you would prefer to skip this patch, instead run \"git rebase --skip\".
41To restore the original branch and stop rebasing run \"git rebase --abort\".
42"
e646c9c8 43unset newbase
a06f678e 44strategy=recursive
58634dbf 45do_merge=
28ed6e7b 46dotest="$GIT_DIR"/rebase-merge
58634dbf 47prec=4
b758789c 48verbose=
a9c3821c 49diffstat=$(git config --bool rebase.stat)
67dad687 50git_am_opt=
190f5323 51rebase_root=
b2f82e05 52force_rebase=
58634dbf
EW
53
54continue_merge () {
55 test -n "$prev_head" || die "prev_head must be defined"
56 test -d "$dotest" || die "$dotest directory does not exist"
57
5be60078 58 unmerged=$(git ls-files -u)
58634dbf
EW
59 if test -n "$unmerged"
60 then
61 echo "You still have unmerged paths in your index"
9b07873a 62 echo "did you forget to use git add?"
66eb64cb 63 die "$RESOLVEMSG"
58634dbf
EW
64 fi
65
889a50e9 66 cmt=`cat "$dotest/current"`
6848d58c 67 if ! git diff-index --quiet --ignore-submodules HEAD --
58634dbf 68 then
e637122e 69 if ! git commit --no-verify -C "$cmt"
f0ef0596
EW
70 then
71 echo "Commit failed, please do not call \"git commit\""
72 echo "directly, but instead do one of the following: "
73 die "$RESOLVEMSG"
74 fi
0e987a12
SB
75 if test -z "$GIT_QUIET"
76 then
77 printf "Committed: %0${prec}d " $msgnum
78 fi
58634dbf 79 else
0e987a12
SB
80 if test -z "$GIT_QUIET"
81 then
82 printf "Already applied: %0${prec}d " $msgnum
83 fi
84 fi
85 if test -z "$GIT_QUIET"
86 then
87 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
58634dbf
EW
88 fi
89
5be60078 90 prev_head=`git rev-parse HEAD^0`
58634dbf 91 # save the resulting commit so we can read-tree on it later
58634dbf
EW
92 echo "$prev_head" > "$dotest/prev_head"
93
94 # onto the next patch:
95 msgnum=$(($msgnum + 1))
5887ac82 96 echo "$msgnum" >"$dotest/msgnum"
58634dbf
EW
97}
98
99call_merge () {
889a50e9 100 cmt="$(cat "$dotest/cmt.$1")"
58634dbf 101 echo "$cmt" > "$dotest/current"
5be60078 102 hd=$(git rev-parse --verify HEAD)
6fd2f5e6 103 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
889a50e9
JS
104 msgnum=$(cat "$dotest/msgnum")
105 end=$(cat "$dotest/end")
0bb733c9 106 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
889a50e9 107 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
0bb733c9 108 export GITHEAD_$cmt GITHEAD_$hd
0e987a12
SB
109 if test -n "$GIT_QUIET"
110 then
111 export GIT_MERGE_VERBOSITY=1
112 fi
0bb733c9 113 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
58634dbf
EW
114 rv=$?
115 case "$rv" in
116 0)
0bb733c9 117 unset GITHEAD_$cmt GITHEAD_$hd
9e4bc7dd 118 return
58634dbf
EW
119 ;;
120 1)
b4372ef1 121 git rerere
66eb64cb 122 die "$RESOLVEMSG"
58634dbf
EW
123 ;;
124 2)
125 echo "Strategy: $rv $strategy failed, try another" 1>&2
66eb64cb 126 die "$RESOLVEMSG"
58634dbf
EW
127 ;;
128 *)
129 die "Unknown exit code ($rv) from command:" \
130 "git-merge-$strategy $cmt^ -- HEAD $cmt"
131 ;;
132 esac
133}
134
6fd2f5e6
JS
135move_to_original_branch () {
136 test -z "$head_name" &&
137 head_name="$(cat "$dotest"/head-name)" &&
138 onto="$(cat "$dotest"/onto)" &&
139 orig_head="$(cat "$dotest"/orig-head)"
140 case "$head_name" in
141 refs/*)
142 message="rebase finished: $head_name onto $onto"
143 git update-ref -m "$message" \
144 $head_name $(git rev-parse HEAD) $orig_head &&
145 git symbolic-ref HEAD $head_name ||
146 die "Could not move back to $head_name"
147 ;;
148 esac
149}
150
58634dbf 151finish_rb_merge () {
6fd2f5e6 152 move_to_original_branch
58634dbf 153 rm -r "$dotest"
0e987a12 154 say All done.
58634dbf
EW
155}
156
1b1dce4b 157is_interactive () {
f8cca019
AE
158 while test $# != 0
159 do
160 case "$1" in
161 -i|--interactive)
162 interactive_rebase=explicit
163 break
164 ;;
165 -p|--preserve-merges)
166 interactive_rebase=implied
167 ;;
168 esac
1b1dce4b 169 shift
f8cca019
AE
170 done
171
172 if [ "$interactive_rebase" = implied ]; then
173 GIT_EDITOR=:
174 export GIT_EDITOR
175 fi
176
177 test -n "$interactive_rebase" || test -f "$dotest"/interactive
1b1dce4b
JS
178}
179
d70b4a8f 180run_pre_rebase_hook () {
c4427656
NS
181 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
182 test -x "$GIT_DIR/hooks/pre-rebase"
d70b4a8f
NS
183 then
184 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
185 echo >&2 "The pre-rebase hook refused to rebase."
186 exit 1
187 }
188 fi
189}
190
9b752a6e
SB
191test -f "$GIT_DIR"/rebase-apply/applying &&
192 die 'It looks like git-am is in progress. Cannot rebase.'
193
1b1dce4b
JS
194is_interactive "$@" && exec git-rebase--interactive "$@"
195
9b752a6e
SB
196if test $# -eq 0
197then
198 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
199 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
200 die 'A rebase is in progress, try --continue, --skip or --abort.'
201 die "No arguments given and $GIT_DIR/rebase-apply already exists."
202fi
203
822f7c73 204while test $# != 0
e646c9c8
JH
205do
206 case "$1" in
c4427656
NS
207 --no-verify)
208 OK_TO_SKIP_PRE_REBASE=yes
209 ;;
031321c6 210 --continue)
51ef1daa 211 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
cd5320f2
SB
212 die "No rebase in progress?"
213
6848d58c 214 git diff-files --quiet --ignore-submodules || {
06aff47b 215 echo "You must edit all merge conflicts and then"
9b07873a 216 echo "mark them as resolved using git add"
031321c6 217 exit 1
06aff47b 218 }
58634dbf
EW
219 if test -d "$dotest"
220 then
889a50e9
JS
221 prev_head=$(cat "$dotest/prev_head")
222 end=$(cat "$dotest/end")
223 msgnum=$(cat "$dotest/msgnum")
224 onto=$(cat "$dotest/onto")
0e987a12 225 GIT_QUIET=$(cat "$dotest/quiet")
58634dbf
EW
226 continue_merge
227 while test "$msgnum" -le "$end"
228 do
229 call_merge "$msgnum"
230 continue_merge
231 done
232 finish_rb_merge
233 exit
234 fi
51ef1daa
JS
235 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
236 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
237 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
0e987a12 238 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
3f735b66
JS
239 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
240 move_to_original_branch
cc120056
SE
241 exit
242 ;;
243 --skip)
51ef1daa 244 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
cd5320f2
SB
245 die "No rebase in progress?"
246
fb6e4e1f 247 git reset --hard HEAD || exit $?
58634dbf
EW
248 if test -d "$dotest"
249 then
b4372ef1 250 git rerere clear
889a50e9
JS
251 prev_head=$(cat "$dotest/prev_head")
252 end=$(cat "$dotest/end")
253 msgnum=$(cat "$dotest/msgnum")
d5e673b6 254 msgnum=$(($msgnum + 1))
889a50e9 255 onto=$(cat "$dotest/onto")
0e987a12 256 GIT_QUIET=$(cat "$dotest/quiet")
d5e673b6
EW
257 while test "$msgnum" -le "$end"
258 do
259 call_merge "$msgnum"
260 continue_merge
261 done
262 finish_rb_merge
263 exit
58634dbf 264 fi
51ef1daa
JS
265 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
266 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
267 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
0e987a12 268 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
6fd2f5e6
JS
269 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
270 move_to_original_branch
031321c6
SE
271 exit
272 ;;
273 --abort)
51ef1daa 274 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
cd5320f2
SB
275 die "No rebase in progress?"
276
b4372ef1 277 git rerere clear
58634dbf
EW
278 if test -d "$dotest"
279 then
0e987a12 280 GIT_QUIET=$(cat "$dotest/quiet")
6fd2f5e6 281 move_to_original_branch
cd5320f2 282 else
51ef1daa 283 dotest="$GIT_DIR"/rebase-apply
0e987a12 284 GIT_QUIET=$(cat "$dotest/quiet")
6fd2f5e6 285 move_to_original_branch
58634dbf 286 fi
97b88dd5 287 git reset --hard $(cat "$dotest/orig-head")
48411d22 288 rm -r "$dotest"
031321c6
SE
289 exit
290 ;;
e646c9c8
JH
291 --onto)
292 test 2 -le "$#" || usage
293 newbase="$2"
294 shift
295 ;;
58634dbf
EW
296 -M|-m|--m|--me|--mer|--merg|--merge)
297 do_merge=t
298 ;;
299 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
300 --strateg=*|--strategy=*|\
301 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
302 case "$#,$1" in
303 *,*=*)
8096fae7 304 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
58634dbf
EW
305 1,*)
306 usage ;;
307 *)
308 strategy="$2"
309 shift ;;
310 esac
311 do_merge=t
312 ;;
a9c3821c
TAV
313 -n|--no-stat)
314 diffstat=
315 ;;
316 --stat)
317 diffstat=t
318 ;;
b758789c
RS
319 -v|--verbose)
320 verbose=t
a9c3821c 321 diffstat=t
0e987a12
SB
322 GIT_QUIET=
323 ;;
324 -q|--quiet)
325 GIT_QUIET=t
326 git_am_opt="$git_am_opt -q"
327 verbose=
328 diffstat=
b758789c 329 ;;
059f446d
BF
330 --whitespace=*)
331 git_am_opt="$git_am_opt $1"
b2f82e05
SR
332 case "$1" in
333 --whitespace=fix|--whitespace=strip)
334 force_rebase=t
335 ;;
336 esac
059f446d 337 ;;
570ccad3
MB
338 --committer-date-is-author-date|--ignore-date)
339 git_am_opt="$git_am_opt $1"
340 force_rebase=t
341 ;;
67dad687 342 -C*)
059f446d 343 git_am_opt="$git_am_opt $1"
67dad687 344 ;;
190f5323
TR
345 --root)
346 rebase_root=t
347 ;;
3f7d9928 348 -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
b2f82e05
SR
349 force_rebase=t
350 ;;
e646c9c8
JH
351 -*)
352 usage
353 ;;
354 *)
355 break
356 ;;
357 esac
358 shift
359done
51b2ead0 360test $# -gt 2 && usage
2db8aaec 361
51ef1daa 362# Make sure we do not have $GIT_DIR/rebase-apply
58634dbf 363if test -z "$do_merge"
7f4bd5d8 364then
9b752a6e 365 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
58634dbf 366 then
51ef1daa 367 rmdir "$GIT_DIR"/rebase-apply
58634dbf
EW
368 else
369 echo >&2 '
9b752a6e
SB
370It seems that I cannot create a rebase-apply directory, and
371I wonder if you are in the middle of patch application or another
51ef1daa
JS
372rebase. If that is not the case, please
373 rm -fr '"$GIT_DIR"'/rebase-apply
9b752a6e 374and run me again. I am stopping in case you still have something
51ef1daa 375valuable there.'
58634dbf
EW
376 exit 1
377 fi
378else
379 if test -d "$dotest"
380 then
28ed6e7b 381 die "previous rebase directory $dotest still exists." \
9b752a6e 382 'Try git rebase (--continue | --abort | --skip)'
58634dbf 383 fi
7f4bd5d8
JH
384fi
385
7f59dbbb 386# The tree must be really really clean.
07e62b73
JK
387if ! git update-index --ignore-submodules --refresh; then
388 echo >&2 "cannot rebase: you have unstaged changes"
389 exit 1
390fi
6848d58c 391diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
32d99544 392case "$diff" in
07e62b73
JK
393?*) echo >&2 "cannot rebase: your index contains uncommitted changes"
394 echo >&2 "$diff"
7f59dbbb
JH
395 exit 1
396 ;;
397esac
99a92f92 398
190f5323
TR
399if test -z "$rebase_root"
400then
401 # The upstream head must be given. Make sure it is valid.
402 upstream_name="$1"
403 shift
404 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
405 die "invalid upstream $upstream_name"
406 unset root_flag
407 upstream_arg="$upstream_name"
408else
409 test -z "$newbase" && die "--root must be used with --onto"
410 unset upstream_name
411 unset upstream
412 root_flag="--root"
413 upstream_arg="$root_flag"
414fi
32d99544 415
a1bf91e0
JH
416# Make sure the branch to rebase onto is valid.
417onto_name=${newbase-"$upstream_name"}
5be60078 418onto=$(git rev-parse --verify "${onto_name}^0") || exit
a1bf91e0 419
9a111c91 420# If a hook exists, give it a chance to interrupt
190f5323 421run_pre_rebase_hook "$upstream_arg" "$@"
9a111c91 422
0cb06644
JH
423# If the branch to rebase is given, that is the branch we will rebase
424# $branch_name -- branch being rebased, or HEAD (already detached)
425# $orig_head -- commit object name of tip of the branch before rebasing
426# $head_name -- refs/heads/<that-branch> or "detached HEAD"
427switch_to=
59e6b23a 428case "$#" in
190f5323 4291)
0cb06644 430 # Is it "rebase other $branchname" or "rebase other $commit"?
190f5323
TR
431 branch_name="$1"
432 switch_to="$1"
0cb06644 433
190f5323
TR
434 if git show-ref --verify --quiet -- "refs/heads/$1" &&
435 branch=$(git rev-parse -q --verify "refs/heads/$1")
0cb06644 436 then
190f5323
TR
437 head_name="refs/heads/$1"
438 elif branch=$(git rev-parse -q --verify "$1")
0cb06644
JH
439 then
440 head_name="detached HEAD"
441 else
442 usage
443 fi
e646c9c8
JH
444 ;;
445*)
0cb06644 446 # Do not need to switch branches, we are already on it.
bcf31618
JH
447 if branch_name=`git symbolic-ref -q HEAD`
448 then
0cb06644 449 head_name=$branch_name
bcf31618
JH
450 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
451 else
0cb06644 452 head_name="detached HEAD"
bcf31618
JH
453 branch_name=HEAD ;# detached
454 fi
0cb06644 455 branch=$(git rev-parse --verify "${branch_name}^0") || exit
e646c9c8 456 ;;
59e6b23a 457esac
0cb06644 458orig_head=$branch
59e6b23a 459
190f5323
TR
460# Now we are rebasing commits $upstream..$branch (or with --root,
461# everything leading up to $branch) on top of $onto
e646c9c8 462
1308c17b
JS
463# Check if we are already based on $onto with linear history,
464# but this should be done only when upstream and onto are the same.
5be60078 465mb=$(git merge-base "$onto" "$branch")
1308c17b
JS
466if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
467 # linear history?
bbf08124 468 ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
7f4bd5d8 469then
b2f82e05
SR
470 if test -z "$force_rebase"
471 then
472 # Lazily switch to the target branch if needed...
473 test -z "$switch_to" || git checkout "$switch_to"
0e987a12 474 say "Current branch $branch_name is up to date."
b2f82e05
SR
475 exit 0
476 else
0e987a12 477 say "Current branch $branch_name is up to date, rebase forced."
b2f82e05 478 fi
7f4bd5d8
JH
479fi
480
0cb06644 481# Detach HEAD and reset the tree
0e987a12 482say "First, rewinding head to replay your work on top of it..."
324c2c31 483git checkout -q "$onto^0" || die "could not detach HEAD"
22e40795 484git update-ref ORIG_HEAD $branch
32d99544 485
a9c3821c
TAV
486if test -n "$diffstat"
487then
488 if test -n "$verbose"
489 then
490 echo "Changes from $mb to $onto:"
491 fi
492 # We want color (if set), but no pager
493 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
494fi
495
e646c9c8 496# If the $onto is a proper descendant of the tip of the branch, then
32d99544 497# we just fast forwarded.
83c31614 498if test "$mb" = "$branch"
32d99544 499then
0e987a12 500 say "Fast-forwarded $branch_name to $onto_name."
6fd2f5e6 501 move_to_original_branch
32d99544
LS
502 exit 0
503fi
504
190f5323
TR
505if test -n "$rebase_root"
506then
507 revisions="$onto..$orig_head"
508else
509 revisions="$upstream..$orig_head"
510fi
511
58634dbf
EW
512if test -z "$do_merge"
513then
0cb06644 514 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
190f5323 515 $root_flag "$revisions" |
3041c324 516 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
6fd2f5e6
JS
517 move_to_original_branch
518 ret=$?
51ef1daa
JS
519 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
520 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
521 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
0e987a12
SB
522 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
523 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
6fd2f5e6 524 exit $ret
58634dbf
EW
525fi
526
527# start doing a rebase with git-merge
528# this is rename-aware if the recursive (default) strategy is used
529
530mkdir -p "$dotest"
531echo "$onto" > "$dotest/onto"
0bb733c9 532echo "$onto_name" > "$dotest/onto_name"
6fd2f5e6 533prev_head=$orig_head
58634dbf 534echo "$prev_head" > "$dotest/prev_head"
6fd2f5e6
JS
535echo "$orig_head" > "$dotest/orig-head"
536echo "$head_name" > "$dotest/head-name"
0e987a12 537echo "$GIT_QUIET" > "$dotest/quiet"
58634dbf
EW
538
539msgnum=0
190f5323 540for cmt in `git rev-list --reverse --no-merges "$revisions"`
58634dbf
EW
541do
542 msgnum=$(($msgnum + 1))
5887ac82 543 echo "$cmt" > "$dotest/cmt.$msgnum"
58634dbf
EW
544done
545
5887ac82
JH
546echo 1 >"$dotest/msgnum"
547echo $msgnum >"$dotest/end"
58634dbf
EW
548
549end=$msgnum
550msgnum=1
551
552while test "$msgnum" -le "$end"
553do
554 call_merge "$msgnum"
555 continue_merge
556done
cc120056 557
58634dbf 558finish_rb_merge